BattlePager = {}

local TIME_DELAY = 2
local timeLeft = TIME_DELAY -- start in TIME_DELAY seconds
local timerValue = -1

local wX
local wY
local playerX
local playerY

function BattlePager.Initialize()
	LayoutEditor.RegisterWindow("BattlePagerMain",L"BattlePager",L"BattlePager",true,true,false,nil )
	
	WindowSetShowing("BattlePagerMain.bg.info", false)
	
	ComboBoxAddMenuItem("BattlePagerMain.Channel", L"/s")
	ComboBoxAddMenuItem("BattlePagerMain.Channel", L"/sc")
	ComboBoxAddMenuItem("BattlePagerMain.Channel", L"/wb")
	ComboBoxAddMenuItem("BattlePagerMain.Channel", L"/p")
	ComboBoxAddMenuItem("BattlePagerMain.Channel", L"/2")
	ComboBoxAddMenuItem("BattlePagerMain.Channel", L"/t4")
	ComboBoxAddMenuItem("BattlePagerMain.Channel", L"/1")
	ComboBoxAddMenuItem("BattlePagerMain.Channel", L"/gu")
	ComboBoxAddMenuItem("BattlePagerMain.Channel", L"/as")
	ComboBoxSetSelectedMenuItem("BattlePagerMain.Channel", 7)
	ComboBoxSetDisabledFlag("BattlePagerMain.Channel", false)
	
	RegisterEventHandler(SystemData.Events.PLAYER_POSITION_UPDATED, "BattlePager.playerPosition")	
end

function BattlePager.playerPosition(worldX, worldY)
	local zoneId = GameData.Player.zone
	local zoneOffset = BattlePager.ZoneOffsets[GameData.Player.zone]
	
	wX = worldX
	wY = worldY
	
	--LabelSetText("EA_Window_WorldMapZoneViewMapMarkersHeader", towstring(tostring(math.floor(wX)) .. ", " .. tostring(math.floor(wY)) .. " : " .. tostring(GameData.Player.zone)))
	
	playerX = math.floor(worldX-zoneOffset.x)
	playerY = math.floor(worldY-zoneOffset.y)
end

function BattlePager.sendAttack()
	local name = TargetInfo:UnitName("selfhostiletarget")
	local str = "Full Damage on " .. tostring(name)
	
	if tostring(name)=="" then
		EA_ChatWindow.Print(towstring("No hostile target selected!"))
	else
		BattlePager.sendMessage(str, "<icon24>")
	end
end

function BattlePager.sendHostileTarget()
	local life = TargetInfo:UnitHealth("selfhostiletarget")
	local name = TargetInfo:UnitName("selfhostiletarget")
	local zoneName = GetZoneName(GameData.Player.zone)
	local areaName = GameData.Player.area.name
    
	local str = tostring(name) .. ": " .. tostring(life) .. "% at " .. tostring(GameData.Player.area.name) .. " in " .. tostring(zoneName)
	
	if tostring(name)=="" then
		EA_ChatWindow.Print(towstring("No hostile target selected!"))
	else
		BattlePager.sendMessage(str, "<icon51>")
	end
end

function BattlePager.sendFriendlyTarget()
	local life = TargetInfo:UnitHealth("selffriendlytarget")
	local name = TargetInfo:UnitName("selffriendlytarget")
	local zoneName = GetZoneName(GameData.Player.zone)
	local areaName = GameData.Player.area.name
    
	local str = tostring(name) .. ": " .. tostring(life) .. "% at " .. tostring(GameData.Player.area.name) .. " in " .. tostring(zoneName)
	
	if tostring(name)=="" then
		EA_ChatWindow.Print(towstring("No friendly target selected!"))
	else
		BattlePager.sendMessage(str, "<icon51>")
	end
end

function BattlePager.printCountdown(elapsed)
    timeLeft = timeLeft - elapsed
    if timeLeft > 0 then
        return -- cut out early
    end
    timeLeft = TIME_DELAY
	
	if timerValue > 0 then
		BattlePager.sendMessage(timerValue, "<icon738>")
		timerValue = timerValue - 1
	elseif timerValue == 0 then
		BattlePager.sendMessage("Go Go Go", "<icon738>")
		timerValue = -1
	end
end

function BattlePager.sendCountdown()
	if(timerValue>-1) then
		timerValue = -1
		BattlePager.sendMessage("CountDown aborted", "<icon738>")
	else
		timerValue = 10
	end
end

function BattlePager.sendInc()
	local zoneName = GetZoneName(GameData.Player.zone)
	local areaName = GameData.Player.area.name
	local message = "INC"
	
	if tostring(areaName) == "" then
		message = "INC @ " .. tostring(zoneName) .. " (" .. tostring(playerX) .. ", " .. tostring(playerY) .. ")"
	else
		message = "INC @ " .. tostring(zoneName) .. " / " .. tostring(areaName) .. " (" .. tostring(playerX) .. ", " .. tostring(playerY) .. ")"
	end
	
	if playerX==0 then
		EA_ChatWindow.Print(towstring("Unable to read your coordinates. Please move your charakter!"))
	else
		BattlePager.sendMessage(tostring(message), "<icon24>")
	end
end

function BattlePager.sendRez()
	local zoneName = GetZoneName(GameData.Player.zone)
	local areaName = GameData.Player.area.name
	local message = ""
	
	if tostring(areaName) == "" then
		message = "Need resurrection @ " .. tostring(zoneName) .. " (" .. tostring(playerX) .. ", " .. tostring(playerY) .. ")"
	else
		message = "Need resurrection @ " .. tostring(zoneName) .. " / " .. tostring(areaName) .. " (" .. tostring(playerX) .. ", " .. tostring(playerY) .. ")"
	end
	
	if playerX==0 then
		EA_ChatWindow.Print(towstring("Unable to read your coordinates. Please move your charakter!"))
	else
		BattlePager.sendMessage(tostring(message), "<icon27>")
	end
	
end

function BattlePager.sendFallBack()
	local zoneName = GetZoneName(GameData.Player.zone)
	local areaName = GameData.Player.area.name
	local message = ""
	
	if tostring(areaName) == "" then
                message = "Fallback form " .. tostring(zoneName) .. " (" .. tostring(playerX) .. ", " .. tostring(playerY) .. ")"
	else
                message = "Fallback from " .. tostring(zoneName) .. " / " .. tostring(areaName) .. " (" .. tostring(playerX) .. ", " .. tostring(playerY) .. ")"
	end
	
	if playerX==0 then
		EA_ChatWindow.Print(towstring("Unable to read your coordinates. Please move your charakter!"))
	else
		BattlePager.sendMessage(tostring(message), "<icon738>")
	end
	
end

function BattlePager.sendGroupUp()
	local zoneName = GetZoneName(GameData.Player.zone)
	local areaName = GameData.Player.area.name
	local message = ""
	
	if tostring(areaName) == "" then
                message = "Group up at " .. tostring(zoneName) .. " (" .. tostring(playerX) .. ", " .. tostring(playerY) .. ")"
	else
                message = "Group up at " .. tostring(zoneName) .. " / " .. tostring(areaName) .. " (" .. tostring(playerX) .. ", " .. tostring(playerY) .. ")"
	end
	
	if playerX==0 then
		EA_ChatWindow.Print(towstring("Unable to read your coordinates. Please move your charakter!"))
	else
		BattlePager.sendMessage(tostring(message), "<icon738>")
	end
	
end

function BattlePager.sendMessage(message, icon)
	local channel = ComboBoxGetSelectedText("BattlePagerMain.Channel")
	local command = tostring(channel) .. " " .. icon .. " " .. tostring(message)

	SendChatText(towstring(command), L"")

end

function BattlePager.tooltip()	
	local tooltips = {
		["BattlePagerMain.icon.attack"] = L"Give order to attack your current target",
		["BattlePagerMain.icon.hostileTarget"] = L"HitPoints of your hostile target",
		["BattlePagerMain.icon.friendlyTarget"] = L"HitPoints of your friendly target",
		["BattlePagerMain.icon.fallBack"] = L"Order a fallback",
		["BattlePagerMain.icon.groupUp"] = L"Order a Group Up",
		["BattlePagerMain.icon.countdown"] = L"Start or abort a CountDown",
		["BattlePagerMain.icon.inc"] = L"Report incoming enemies",
		["BattlePagerMain.icon.rez"] = L"Ask for resurrection"
	}
	
	WindowSetTintColor(SystemData.MouseOverWindow.name, 150, 150, 150)
	WindowSetAlpha(SystemData.MouseOverWindow.name, 255)
	
	WindowSetShowing("BattlePagerMain.bg.info", true)
	LabelSetText("BattlePagerMain.lbl.info", tooltips[SystemData.MouseOverWindow.name])
end

function BattlePager.endTooltip()
	WindowSetShowing("BattlePagerMain.bg.info", false)
	LabelSetText("BattlePagerMain.lbl.info", L"")
	
	WindowSetTintColor(SystemData.MouseOverWindow.name, 255, 255, 255)
	WindowSetAlpha(SystemData.MouseOverWindow.name, 255)
end
